﻿using UnityEngine;
using System.Collections;
using UnityEngine.PlayerLoop;

namespace Mod
{
    public class Mod
    {
        public static AnimationCurve gunCurve = new AnimationCurve(new Keyframe(0f, 0f), new Keyframe(0.2f, 0f), new Keyframe(0.3f, -70f), new Keyframe(0.9f, -70f), new Keyframe(1f, 0f));

        public static AnimationCurve patronCurve = new AnimationCurve(new Keyframe(0f, 0f), new Keyframe(1f, 0.14f));

        public const float ColMultiply = 2.8571429f;

        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Double Barrel Shotgun",
                    DescriptionOverride = "Can Kill.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Sprites/DBShotgun-thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        SpriteRenderer mainsprite = Instance.GetComponent<SpriteRenderer>();

                        mainsprite.sprite = ModAPI.LoadSprite("Sprites/DBShotgunButt.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        PolygonCollider2D Col = Instance.GetOrAddComponent<PolygonCollider2D>();
                        Col.SetPath(0, new Vector2[]
                        {
                            new Vector2(0.0400297642f * ColMultiply, 0.0500173569f * ColMultiply),
                            new Vector2(0.0207955837f * ColMultiply, 0.0400002003f * ColMultiply),
                            new Vector2(0.000384092331f * ColMultiply, 0.0196754932f * ColMultiply),
                            new Vector2(-0.00980054587f * ColMultiply, 0.0298006982f * ColMultiply),
                            new Vector2(-0.119999886f * ColMultiply, 0.0298578739f * ColMultiply),
                            new Vector2(-0.119999997f * ColMultiply, -0.049999997f * ColMultiply),
                            new Vector2(-0.0799911022f * ColMultiply, -0.0499999523f * ColMultiply),
                            new Vector2(-0.0597202778f * ColMultiply, -0.0299298763f * ColMultiply),
                            new Vector2(-0.040084362f * ColMultiply, -0.0300879478f * ColMultiply),
                            new Vector2(-0.0201852322f * ColMultiply, -0.019903183f * ColMultiply),
                            new Vector2(-0.0153441429f * ColMultiply, -0.0100610256f * ColMultiply),
                            new Vector2(-0.00993847847f * ColMultiply, -0.019957304f * ColMultiply),
                            new Vector2(0.0100135803f * ColMultiply, -0.0199828148f * ColMultiply),
                            new Vector2(0.0300962925f * ColMultiply, -8.20159912e-05f * ColMultiply),
                            new Vector2(0.0400247574f * ColMultiply, -0.000358819962f * ColMultiply),
                            new Vector2(0.0501582623f * ColMultiply, -0.00979495049f * ColMultiply),
                            new Vector2(0.07978037f * ColMultiply, -0.00983814895f * ColMultiply),
                            new Vector2(0.100657307f * ColMultiply, 0.0101532564f * ColMultiply),
                            new Vector2(0.119516008f * ColMultiply, 0.0103273299f * ColMultiply),
                            new Vector2(0.230059862f * ColMultiply, 0.00985431671f * ColMultiply),
                            new Vector2(0.250309944f * ColMultiply, 0.0300617218f * ColMultiply),
                            new Vector2(0.379924774f * ColMultiply, 0.0300161839f * ColMultiply),
                            new Vector2(0.379984856f * ColMultiply, 0.0500376225f * ColMultiply),
                            new Vector2(0.119999997f * ColMultiply, 0.049999997f * ColMultiply)
                        });

                        var Weapon = Instance.transform;

                        var casingOld = Instance.transform.Find("BulletCasing(Clone)").gameObject;

                        casingOld.SetActive(false);

                        GameObject Casing = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/BulletCasing"));
                        Casing.transform.parent = Instance.transform;
                        Casing.transform.rotation = Weapon.rotation;
                        Casing.transform.localRotation = new Quaternion(0f, 0f, 0.8192f, 0.5736f);
                        Casing.transform.localPosition = new Vector3(0.3477f, 0.1711f);
                        Casing.name = "Shells";
                        var CasTex = Casing.GetComponent<ParticleSystemRenderer>();
                        CasTex.material.mainTexture = ModAPI.LoadTexture("Sprites/casing.png");
                        var CasMain = Casing.GetComponent<ParticleSystem>().main;
                        CasMain.startSize3D = true;
                        CasMain.startSizeXMultiplier = 0.131f;
                        CasMain.startSizeYMultiplier = 0.1f;
                        CasMain.startSizeZMultiplier = 1f;
                        var CasCollision = Casing.GetComponent<ParticleSystem>().collision;
                        CasCollision.radiusScale = 0.06f;
                        var CasEmission = Casing.GetComponent<ParticleSystem>().emission;
                        CasEmission.burstCount = 2;
                        var CasShape = Casing.GetComponent<ParticleSystem>().shape;
                        CasShape.meshScale = 0.007f;

                        GameObject HammerCenter = new GameObject("HammerCenter");
                        HammerCenter.transform.SetParent(Weapon);
                        HammerCenter.transform.rotation = Weapon.rotation;
                        HammerCenter.transform.localPosition = new Vector3(0.3286f, 0.0571f, 0f);
                        HammerCenter.AddComponent<Optout>();

                        GameObject Barrels = new GameObject("Barrels");
                        Barrels.transform.SetParent(HammerCenter.gameObject.transform);
                        Barrels.transform.localPosition = new Vector3(0.3571f, 0.0286f, 0.2f);
                        Barrels.layer = LayerMask.NameToLayer("Objects");

                        GameObject NewPatron = new GameObject("Patron");
                        NewPatron.transform.SetParent(HammerCenter.gameObject.transform);
                        NewPatron.transform.rotation = HammerCenter.gameObject.transform.rotation;
                        NewPatron.transform.localScale = new Vector3(0.65f, 0.5f, 1f);
                        NewPatron.transform.localPosition = new Vector3(0.14f, 0.064f, 0f);
                        SpriteRenderer PatronSprite = NewPatron.AddComponent<SpriteRenderer>();
                        PatronSprite.sprite = ModAPI.LoadSprite("Sprites/casing.png");
                        PatronSprite.sortingOrder = -1;
                        TranslationAnimationBehaviour anim2 = NewPatron.AddComponent<TranslationAnimationBehaviour>();
                        anim2.Duration = 0.2f;
                        anim2.DistanceOverTime = patronCurve;
                        System.Type type = typeof(TranslationAnimationBehaviour);
                        System.Reflection.BindingFlags flags = System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic;
                        type.GetField("startPos", flags).SetValue(anim2, new Vector3(-0.16f, 0.064f, 0f));

                        PolygonCollider2D Col2 = Barrels.GetOrAddComponent<PolygonCollider2D>();
                        Col2.SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.140000001f * ColMultiply,0.0199999996f * ColMultiply),
                            new Vector2(-0.139999986f * ColMultiply,2.29477882e-06f * ColMultiply),
                            new Vector2(-0.129727498f * ColMultiply,8.50372016e-05f * ColMultiply),
                            new Vector2(-0.129819512f * ColMultiply,-0.0199994147f * ColMultiply),
                            new Vector2(-5.85317612e-05f * ColMultiply,-0.0199918151f * ColMultiply),
                            new Vector2(-4.59998846e-05f * ColMultiply,-5.89378178e-05f * ColMultiply),
                            new Vector2(0.139999986f * ColMultiply,-9.64999199e-05f * ColMultiply),
                            new Vector2(0.140000001f * ColMultiply,0.0199999996f * ColMultiply)
                        });

                        if (Instance.transform.lossyScale.x < 0)
                        {
                            Barrels.transform.localPosition = new Vector3(-0.3571f, 0.0286f, 0.2f);
                            Barrels.transform.localScale = new Vector3(-1f, 1f, 1f);
                            Casing.transform.localScale = new Vector3(1f, 1f, 1f);
                            NewPatron.transform.localScale = new Vector3(-0.65f, 0.5f, 1f);
                            anim2.Multiplier = -1f;
                            type = typeof(TranslationAnimationBehaviour);
                            flags = System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic;
                            type.GetField("startPos", flags).SetValue(anim2, new Vector3(0.16f, 0.064f, 0f));
                        }
                        else
                        {
                            Barrels.transform.localPosition = new Vector3(0.3571f, 0.0286f, 0.2f);
                            Barrels.transform.localScale = new Vector3(1f, 1f, 1f);
                            Casing.transform.localScale = new Vector3(1f, 1f, 1f);
                            NewPatron.transform.localScale = new Vector3(0.65f, 0.5f, 1f);
                        }

                        Barrels.transform.rotation = HammerCenter.transform.rotation;
                        Barrels.AddComponent<Optout>();
                        SpriteRenderer BarrelsSprite = Barrels.AddComponent<SpriteRenderer>();
                        BarrelsSprite.sprite = ModAPI.LoadSprite("Sprites/Barrels.png");
                        BarrelsSprite.sortingOrder = 0;

                        RotationAnimationBehaviour anim = HammerCenter.AddComponent<RotationAnimationBehaviour>();
                        anim.Duration = 1.89f;

                        anim.DegreeOverTime = gunCurve;

                        DoubleBarrelGunBehaviour mainbehaviour = Instance.AddComponent<DoubleBarrelGunBehaviour>();

                        mainbehaviour.animation = anim;

                        mainbehaviour.ReloadParticles = Casing.GetComponent<ParticleSystem>();

                        FirearmBehaviour firearmmy = Instance.GetComponent<FirearmBehaviour>();

                        firearmmy.barrelPosition = new Vector2(1.089f, 0.11f);

                        PhysicalBehaviour phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.HoldingPositions = new[]
                        {
                            new Vector3(0.2f, 0.028571429f),
                            new Vector3(0.514285722f, 0.085714287f)
                        };

                        //mainbehaviour.firearm = firearmmy;

                        mainbehaviour.patronanim = anim2;

                    }
                }
            );
        }
    }
    public class DoubleBarrelGunBehaviour : MonoBehaviour
    {
        public void Awake()
        {
            this.firearm = base.GetComponent<FirearmBehaviour>();
            firearm.IgnoreUse = true;
        }
        private IEnumerator ReloadRoutine()
        {
            if (isBusy)
            {
                yield break;
            }
            firearm.Shoot();
            isBusy = true;
            firearm.IgnoreUse = true;
            animation.Play();
            yield return new WaitForSeconds(0.756f);
            ReloadParticles.Play();
            yield return new WaitForSeconds(0.164f);
            patronanim.Play();
            yield return new WaitForSeconds(0.234f);
            patronanim.Play();
            yield return new WaitForSeconds(0.736f);
            firearm.IgnoreUse = true;
            isBusy = false;
            yield break;
        }

        public void Use(ActivationPropagation activation)
        {
            if (base.enabled)
            {
                base.StartCoroutine(ReloadRoutine());
            }
        }

        public TranslationAnimationBehaviour patronanim;

        public RotationAnimationBehaviour animation;

        public FirearmBehaviour firearm;

        public ParticleSystem ReloadParticles;

        private bool isBusy;
    }
}